<?php

require ("../lib-abdesk.php");

CheckCookie();
session_start();

require ("../lib-links.php");

function GoBackToFormWithError($err)
{
	$_SESSION[linksdb_adder_error]=$err;
	header("Location: multi_link_adder_form.php");
	exit;
}

function array_idiff($array1, $array2) 
{ 

foreach ($array1 as $key=>$element) 
{ 
     foreach($array2 as $key2=>$element2) 
     { 
         if (strtolower($element) == strtolower($element2)) 
         { 
             unset($array1[$key]); 
         } 
     } 
} 

$diff = array_values($array1);

return $diff; 
}

$_SESSION[linksdb_multi_adder_urls]=$_POST[urls];
$_SESSION[linksdb_adder_dateofcollection]=$_POST[dateofcollection];
$_SESSION[linksdb_multiadder_sourcenotes]=$_POST[sourcenotes];
$_SESSION[linksdb_multiadder_shortdesc]=$_POST[shortdesc];

$handle=ConnectToDb($linksdb_name);

$rawurls = $_POST[urls];

if (!$rawurls)
{	GoBackToFormWithError("no urls");
	exit;
}

$sourcenotes=$_POST[sourcenotes];
$shortdesc=$_POST[shortdesc];
CleanInput($shortdesc);
CleanInput($sourcenotes);

$arr_urls=explode("\r\n", $rawurls);
array_walk($arr_urls, RemoveWhitespaceEtcFromTagArr);
$arr_urls=ArrRemoveEmptyValues($arr_urls);
$arr_urls=array_iunique($arr_urls);

$arr_urls=array_merge($arr_urls);
$unusednum=0;
$linenum=0;

foreach ($arr_urls as $line)
{	
	$len=strlen($line);

	if (BackslashesDetectedIn($line) || $len<8 || ColonEtcAbsentIn($line) )
	{
		$unusedlines[$linenum]=$line;
		unset($arr_urls[$linenum]);
		$unusednum++;
	}
	$linenum++;
}

if (!$arr_urls)
{	GoBackToFormWithError("no urls");
	exit;
}

echo "<html><head><title>ABDesktop Multiple Link Adder Results</title>
<link rel=stylesheet href=\"css/l.css\" type=\"text/css\">
<style type=\"text/css\"> 
</style><body><center>";
LinksNav();
echo "<h1>ABDesktop Multiple Link Adder Results</h1></center>
<p>";

echo "<div id='maintext'><pre>";

$arr_urls=array_merge($arr_urls);
$query_to_issue="SELECT url, url_id from UrlInfo WHERE ( ";


$z=0;
foreach ($arr_urls as $url)
{
	$cleanurl = MakeRawUrlClean($url);
	$arr_urls[$z] = $cleanurl;
	
	$query_to_issue .= "url = '$cleanurl' OR ";
	$z++;
}
$query_to_issue = substr($query_to_issue, 0, -4);
$query_to_issue .= ")";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

$y=0;
if (mysql_num_rows($query_result) > 0)
{	$urlexists="true";
	while ($info = mysql_fetch_array($query_result) )
	{	$url=$info[url];
		$cleanurl = MakeRawUrlClean($url);
		$existing_urlids[$y]=$info[url_id];
		$existing_urls[$y]=$url;
		$y++;
	}
	array_merge($existing_urls);
}

if ($existing_urls)
{
	$insert_urls=array_idiff($arr_urls, $existing_urls);
}
else
{	$insert_urls=$arr_urls;
}
PrintArr($arr_urls, "URLs you input:");

echo "<b>";
PrintArr($insert_urls, "Added URLs:");
echo "</b>";
if ($existing_urls)
{
	PrintArr($existing_urls, "Existing thus excluded URLs:");
}
if ($unusedlines)
{
	PrintArr($unusedlines, "Unused lines:");
}

echo "<p><br>";

$query_to_issue="INSERT INTO UrlInfo (protocol, hostname, suffix, path, dirsonly, fullfilename, filenameonly, filext, allparams, anchor, username, password, port, numofdots, isdynamicurl, url, repository, forsite, whenadded, sourcenotes, shortdesc) VALUES\n";

$shortdesc=EncloseOrNull($shortdesc, "'");
$sourcenotes=EncloseOrNull($sourcenotes, "'");

if ($insert_urls)
{
	$x=0;
	foreach ($insert_urls as $cleanurl)
	{
		GetUrlDetails($cleanurl, $x);
		$query_to_issue .= "\n($protocol[$x], $hostname[$x], $suffix[$x], $path[$x], $dirsonly[$x], $fullfilename[$x], $filenameonly[$x], $filext[$x], $params[$x], $anchor[$x], $username[$x], $password[$x], $port[$x], $numofdots[$x], $dynamicurlornot[$x], '$cleanurl', 'y', 'n', now(), $sourcenotes, $shortdesc), \n";
		$x++;
	}

	$query_to_issue = substr($query_to_issue, 0, -3);
	$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

	$addedurl_id = mysql_insert_id();

	echo "<p><b>Query:</b> $query_to_issue ";
	echo "<p><b>ID of first inserted URL:</b> $addedurl_id";
}

	$rawdate=$_POST[dateofcollection];
	if ($rawdate && ( $existing_urls || $insert_urls) )
	{
		$cleandate=MakeRawDateClean($rawdate);
		$datetimestamp=MakeIntoUnixTime($rawdate);
		$datetimestamp = date("Y-m-d H:i:s", $datetimestamp);
		$z=0;
		$query_to_issue="INSERT INTO UrlDatesOfCollection (url_id, timestamp, orig_datestring) VALUES \n";
		
		while ($z<$x)
		{
			$query_to_issue .= "\n('$addedurl_id', '$datetimestamp', '$cleandate'), \n";
			$addedurl_id++;
			$z++;
		}
		
		if ($existing_urlids)
		{
			foreach ($existing_urlids as $thisurlid)
			{	$query_to_issue .= "\n('$thisurlid', '$datetimestamp', '$cleandate'), \n";
			}
		}
		
		$query_to_issue = substr($query_to_issue, 0, -3);
		
		echo "<p><br><b>Date query:</b> $query_to_issue ";
		
		mysql_query($query_to_issue,$handle);
		$errormessage=mysql_error();
	}
?>